function x = iQDLifting_1(L, H, dinfo, pinfo, lsi)
% Stage 1 reconstruction: reconstruct original 2-D signal with Lower 
% band and Higher band via directional lifting  on qincux lattice
% 
% USAGE:
%    x = iQDLifting(L, H, dinfo, pinfo, lsi)
% INPUT:   
%    L    - Lower band
%    H    - Higher band
%  dinfo  - directional information 
%  pinfo  - partition information
%    lsi  - Lifting lattice
% OUTPUT:
%    x    - reconstructed signal
% 
% REFERENCE:
%    W. Ding, F. Wu, and S. Li, ¡°Lifting-based wavelet transform
%    with directionally spatial prediction,¡± in Proc. Picture 
%    Coding Symposium 2004, San Francisco, CA, USA, Dec. 2004.

y{1} = L;
y{2} = H;

N = size(lsi, 1);
y = Normalize(y, lsi{N,1}, lsi{N,2});
y = iQExtract(y);
for i = (N-1):-1:1
     f  = lsi{i,2}; % filter taps
     fd = lsi{i,3}; % filter delay: z(-fd)
     cd = lsi{i,4}; % component delay which corresponds non-one diagonal components: z(-cd)    
    if lsi{i,1}=='p'
        y{2} = Predict(y, f, dinfo, pinfo, fd);
    elseif lsi{i,1}=='u'
         y{1} = Update(y, f, dinfo, pinfo, fd);
    end
end
x = QMerge(y{1}, y{2}); 


function [h] = Predict(x, f, dinfo, pinfo, fd)
% primal lift: predicting along conlumns
s = x{1};
d = x{2};
[r c]= size(d);
dset = [0 1; 1 2; 0 0; 2 1; 1 0; 2 -1; 0 0; 1 -2];
ldset = length(dset);

h_all = zeros(r, c, ldset);
h = zeros(r, c);
bw = 1;
bh = 2;
br = r/bh;
bc = c/bw;

rextn = 2;
cextn = 2;

% symmetric extension
extns  = extn2D(s',1:(rextn+1), 'symodd')'; % odd symmtric extension with rextn samples for each row
extns  = extn2D(extns, 1:(cextn+1), 'symodd'); % odd symmtric extension with cextn samples for each row 
% generate 
% Predict for all spatial directions except directiona 
% 3 and 7 since they lie in half pixel position

for i = 1:ldset;
%     if (i~=3&i~=7)
    h_all(:, :, i) = d(:, :) + 0.5*extns( (1:r)+cextn + dset(i,1), (1:c)+rextn + dset(i,2) ) ...
                                 + 0.5*extns( (1:r)+cextn - dset(i,1), (1:c)+rextn - dset(i,2) );
%     end
end

% generate half pixel value for direction 3
halfh3 = zeros(1+r, 1+c);
i = 1:(1+r);
j = 1:(1+c);
        half3(i, j) = (-extns(cextn + i + 1, rextn + j -2) + 3*extns(cextn + i, rextn + j -1) + ...
            3*extns(cextn + i - 1, rextn + j) - extns(cextn + i - 2, rextn + j + 1) )/4;

% predict for direction 3
    h_all(1:r, 1:c, 3) = d(1:r, 1:c) + 0.5*half3(1:r, 1:c) + 0.5*half3((1:r)+1, (1:c)+1);
    
% generate half pixel value for direction 7
halfh7 = zeros(1+r, 1+c);
i = 1:(1+r);
j = 1:(1+c);
        half7(i, j) = (-extns(cextn + i - 2 , rextn + j - 1 -1) + 3*extns(cextn + i -1, rextn + j -1) + ...
            3*extns(cextn + i , rextn + j + 1 - 1) - extns(cextn + i + 1, rextn + j + 2 -1) )/4;

% predict for direction 7
    h_all(1:r, 1:c, 7) = d(1:r, 1:c) + 0.5*half7((1:r), (1:c)+1) + 0.5*half7((1:r)+1, (1:c));


for i = 1:br
    for j = 1:bc
        roff = (i-1)*bh;
        coff = (j-1)*bw;
        h((roff+1):(roff+bh), (coff+1):(coff+bw)) = h_all((roff+1):(roff+bh), (coff+1):(coff+bw), dinfo(i,j));
    end
end

function [l] = Update(x, f, dinfo, pinfo, fd)
% dual lift: updating along conlumns
s = x{1};
d = x{2};
[r c]= size(d);
dset = [0 1; 1 2; 0 0; 2 1; 1 0; 2 -1; 0 -0; 1 -2];
ldset = length(dset);

l_all = zeros(r, c, ldset);
l = zeros(r, c);
bw = 1;
bh = 2;
br = r/bh;
bc = c/bw;
rextn = 2;
cextn = 2;

% symmetric extension
extnd  = extn2D(d',1:(rextn+1), 'symodd')'; % odd symmtric extension with rextn samples for each row
extnd  = extn2D(extnd, 1:(cextn+1), 'symodd'); % odd symmtric extension with cextn samples for each row 

% Update for all spatial directions except direction 
% 3 and 7 since they lie in half pixel position

for i = 1:ldset;
%     if (i~=3&i~=7)
    l_all(:, :, i) = s(:, :) - 0.25*extnd( (1:r)+cextn + dset(i,1), (1:c)+rextn + dset(i,2) ) ...
                                 - 0.25*extnd( (1:r)+cextn - dset(i,1), (1:c)+rextn - dset(i,2) );
%     end
end

% generate half pixel value for direction 3
half3 = zeros(1+r, 1+c);
i = 1:(1+r);
j = 1:(1+c);
        half3(i, j) = (-extnd(cextn + i + 1, rextn + j -2) + 3*extnd(cextn + i, rextn + j -1) + ...
            3*extnd(cextn + i - 1, rextn + j) - extnd(cextn + i - 2, rextn + j + 1) )/4;

% predict for direction 3
    l_all(1:r, 1:c, 3) = s(1:r, 1:c) - 0.25*half3(1:r, 1:c) - 0.25*half3((1:r)+1, (1:c)+1);
    
% generate half pixel value for direction 7
half7 = zeros(1+r, 1+c);
i = 1:(1+r);
j = 1:(1+c);
        half7(i, j) = (-extnd(cextn + i - 2 , rextn + j - 1 -1) + 3*extnd(cextn + i -1, rextn + j -1) + ...
            3*extnd(cextn + i , rextn + j + 1 - 1) - extnd(cextn + i + 1, rextn + j + 2 -1) )/4;

% predict for direction 7
    l_all(1:r, 1:c, 7) = s(1:r, 1:c) - 0.25*half7((1:r), (1:c)+1) - 0.25*half7((1:r)+1, (1:c));

% Pick the right one with dinfo
for i = 1:br
    for j = 1:bc
        roff = (i-1)*bh;
        coff = (j-1)*bw;
        l((roff+1):(roff+bh), (coff+1):(coff+bw)) = l_all((roff+1):(roff+bh), (coff+1):(coff+bw), dinfo(i,j));
    end
end


function y = Normalize(x, Lscale, Hscale)

y{1} = (1/Lscale)*x{1};
y{2} = (1/Hscale)*x{2};

function x  = QMerge(L, H)
% Spliting along conlumns
%    Input:     L - Lower band
%               H - Lower band
%   Output:      x - recontructed signal
%   Notes: the indices of the signal is supposed to
%          be 0, 1, 2, ..., M-1 and  0, 1, 2, ..., N-1
%          for the size of MxN. This is not consistent
%          with the convention of MATLAB                                     
Le = L(:, 1:2:end);
Lo = L(:, 2:2:end);
Le = downsample(Le, 2);
Le = upsample(Le, 2);
Lo = downsample(Lo, 2, 1);
Lo = upsample(Lo, 2, 1);
L(:,1:2:end) = Le;
L(:,2:2:end) = Lo;
He = H(:, 1:2:end);
Ho = H(:, 2:2:end);
He = downsample(He, 2, 1);
He = upsample(He, 2, 1);
Ho = downsample(Ho, 2);
Ho = upsample(Ho, 2);
H(:,1:2:end) = He;
H(:,2:2:end) = Ho;
x = L+H;

% for i=1:h
%     for j=1:w
%         if mod(i+j,2)==0
%             x(i,j) = L(i,j);
%         else
%             x(i,j) = H(i,j);            
%         end
%     end
% end

function y = iQExtract(x)
[h, w] = size(x{1});
L = x{1};
Le = L(:, 1:2:w);
Lo = L(:, 2:2:w);
Let = upsample(Le, 2);
Lot = upsample(Lo, 2, 1);
y{1}(:, 1:2:w) = Let(:,:);
y{1}(:, 2:2:w) = Lot(:,:);
[h, w] = size(x{2});
H = x{2};
He = H(:, 1:2:w);
Ho = H(:, 2:2:w);
Het = upsample(He, 2, 1);
Hot = upsample(Ho, 2);
y{2}(:, 1:2:w) = Het(:,:);
y{2}(:, 2:2:w) = Hot(:,:);


